<template>
  <div>
    <div class="fields">
      <st-title text="Fecha y hora de la cita"/>
      <v-autocomplete
        v-model="idTutor"
        :items="tutors"
        item-text="nombre"
        item-value="idTutor"
        label="Tutor"
        required/>
      <st-legend :legend="legend" isModal/>
      <st-calendar ref="calendar" styleInterval="workday" :idTutor ="idTutor" :currUnit="idUnitTutorship" :height="400"/>
    </div>

    <div class="content-footer">
      <st-secondary-btn nombre="Cancelar" @click="$emit('cancel')"/>
      <st-primary-btn
        nombre="Registrar cita"
        @click="sendToRegisterAppointment"
        :disable="tutors.length === 0"
        :loading="loading"
      />
    </div>
  </div>
</template>

<script>
import Calendar from "@/components/Calendar";
import ColorLegend from "@/components/ColorLegend.vue"

export default {
  name: "TutorshipSessionModalStepThree",
  components: {
    "st-calendar": Calendar,
    "st-legend": ColorLegend
  },
  props: {appointment: Object, loading: Boolean, idUnitTutorship: String},
  data() {
    return {
      idTutor: "",
      tutors: [],
      payload: {},
      currUnit : "",
      legend: [
        {color: '#FFFFFF', text: 'Horario disponible'},
        {color: '#51EAB1', text: 'Horario seleccionado'},
        {color: '#999999', text: 'Horario no disponible'} 
      ]
    }
  },
  methods: {
    async searchTutorsAvailables() {
      const idStudent = this.appointment.student.idAlumno;
      const idTutorship = this.$route.params.id;
      try {
        let response = await this.$api.getTutorsForStudentInTutorship(idTutorship, idStudent, false);
        let tutors = response.data.data;
        this.tutors.splice(0, this.tutors.length);
        tutors.forEach(t => this.tutors.push(t));
      } catch (error) {
      }
    },
    sendToRegisterAppointment() {
      let event = [...this.$refs.calendar.getEvents()].pop();
      let payload = {
        idTutor: this.idTutor,
        start: new Date(event.start).toISOString(),
        end:   new Date(event.end).toISOString(),
      };
      this.$emit('next', payload);
    }
  },
  mounted() {
    let now = this.appointment
   // this.currUnit = this.$store.state.role.idUnit
    if (now && now!=={} && now.student && now.student!=={}) {
      // si el student de old no existe, ha cambiado efectivamente el now
      this.searchTutorsAvailables();
    }
  }
}
</script>

<style scoped>

</style>
